## acl2 4.3

=== books/Makefile ===
#; ACL2 Version 4.3 -- A Computational Logic for Applicative Common Lisp
#; Copyright (C) 2011  University of Texas at Austin

#; This version of ACL2 is a descendent of ACL2 Version 1.9, Copyright
#; (C) 1997 Computational Logic, Inc.  See the documentation topic NOTES-2-0.

#; This program is free software; you can redistribute it and/or modify
#; it under the terms of the GNU General Public License as published by
#; the Free Software Foundation; either version 2 of the License, or
#; (at your option) any later version.

#; This program is distributed in the hope that it will be useful,
#; but WITHOUT ANY WARRANTY; without even the implied warranty of
#; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#; GNU General Public License for more details.

#; You should have received a copy of the GNU General Public License
#; along with this program; if not, write to the Free Software
#; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#; Written by:  Matt Kaufmann               and J Strother Moore
#; email:       Kaufmann@cs.utexas.edu      and Moore@cs.utexas.edu
#; Department of Computer Sciences
#; University of Texas at Austin
#; Austin, TX 78712-1188 U.S.A.

# This file certifies all the books that come with the system by asking the
# appropriate subdirectories certify their books.  The subsidiary Makefiles
# take advantage of a makefile, Makefile-generic, in this directory, which is
# derived from one written by Bishop Brock.

# For example, to clean and time book certification (including workshops):
# make clean all-plus

# We do not set variable ACL2 set here, because the value here would be
# overriden anyhow by the values in the subsidiary Makefiles, which get their
# value from file Makefile-generic.  However, ACL2 can be set on the command
# line, e.g.:
# make ACL2=acl2
# make ACL2=/usr/local/bin/acl2 TIME=/usr/bin/time
# make ACL2=/u/acl2/v2-9/acl2-sources/saved_acl2

TIME = time

# Directories go here; first those before certifying arithmetic/top-with-meta,
# then those afterwards.

# NOTE!  This does *not* touch directory nonstd.

# Note: arithmetic-4 could be added in analogy to arithmetic-5.

DIRS1 = cowles arithmetic meta
DIRS2_EXCEPT_WK_COI = ordinals data-structures bdd ihs arithmetic-2 arithmetic-3 arithmetic-5 \
	misc models/jvm/m1 models/jvm/m5 proofstyles rtl arithmetic-3/extra sorting make-event parallel hints \
	fix-cert finite-set-theory finite-set-theory/osets powerlists textbook \
	defexec symbolic \
	data-structures/memories unicode str concurrent-programs/bakery \
	concurrent-programs/german-protocol deduction/passmore clause-processors \
	quadratic-reciprocity tools paco hacking hons-bdds security regex \
        defsort hons-archive serialize wp-gen xdoc system tutorial-problems cutil
DIRS2_EXCEPT_WK = $(DIRS2_EXCEPT_WK_COI) coi misc/misc2
DIRS2 = $(DIRS2_EXCEPT_WK) workshops
SHORTDIRS2 = ordinals data-structures bdd

# The following can be any subset of DIRS2, and can be set by the user
# on the command line, e.g., from the ACL2 sources directory:
#   make -j 8 regression ACL2_BOOK_DIRS='symbolic paco'
# The directory dependencies (below) should guarantee that all
# necessary supporting directories are made before the ones specified
# explicitly in ACL2_BOOK_DIRS.
ACL2_BOOK_DIRS ?= $(DIRS2)

ifdef ACL2
	ACL2_FOR_HONS = $(ACL2)
else
	ACL2_FOR_HONS ?= `cd .. ; pwd`/saved_acl2h
endif

# Since we have specified that ACL2_BOOK_DIRS is to be a subset of
# DIRS2, we do need to add it explicitly on the next line.
.PHONY: $(DIRS1) $(DIRS2)

# Same as all-plus below, using DIRS2_EXCEPT_WK instead of DIRS2.  Much faster!!  Omits
# books less likely to be needed, in particular, under workshops/.
all:
	@date ; $(TIME) $(MAKE) all-aux


# Next, specify all of the directory dependencies.  At this point we do this
# manually by inspecting the Makefiles.
arithmetic: cowles
meta: arithmetic
ordinals: top-with-meta-cert
ihs: arithmetic data-structures
misc: data-structures top-with-meta-cert ordinals arithmetic ihs arithmetic-2 arithmetic-3
make-event: misc arithmetic-3 arithmetic rtl
arithmetic-2: ihs
rtl: arithmetic meta top-with-meta-cert ordinals ihs misc arithmetic-2
# arithmetic-3 has no dependencies (but see arithmetic-3/extra)
arithmetic-3/extra: arithmetic-3 ihs rtl arithmetic-2 arithmetic-3
# arithmetic-5 has no dependencies
finite-set-theory: arithmetic ordinals
finite-set-theory/osets: unicode
powerlists: arithmetic ordinals data-structures
textbook: arithmetic top-with-meta-cert ordinals ihs
defexec: arithmetic misc ordinals make-event
hons-bdds: misc clause-processors
symbolic: arithmetic arithmetic-2 data-structures ihs misc ordinals models/jvm/m5
data-structures/memories: arithmetic-3 misc
unicode: arithmetic arithmetic-3 ihs ordinals tools
proofstyles: arithmetic-2 ordinals misc top-with-meta-cert
concurrent-programs/bakery: misc ordinals
concurrent-programs/german-protocol: misc
deduction/passmore: 
serialize: tools
clause-processors: top-with-meta-cert make-event arithmetic-3 textbook arithmetic \
	misc tools data-structures arithmetic-5
quadratic-reciprocity: rtl
misc/misc2: rtl make-event coi top-with-meta-cert
hints: make-event
models/jvm/m1: arithmetic-3/extra
models/jvm/m5: top-with-meta-cert ordinals misc ihs
# models/jvm/m5 is needed for paco/books, not paco
paco: ihs ordinals top-with-meta-cert
hacking: misc
parallel: make-event tools
security: make-event arithmetic-3
sorting: arithmetic-3/extra
tools: arithmetic-5 misc
regex: tools cutil
defsort: misc make-event unicode tools
hons-archive: defsort unicode tools arithmetic-3
str: arithmetic unicode defsort tools make-event
coi: arithmetic arithmetic-2 arithmetic-3 data-structures ihs make-event \
	misc ordinals rtl
wp-gen: ordinals
xdoc: str unicode finite-set-theory/osets tools
system: tools arithmetic arithmetic-5
cutil: xdoc tools str misc finite-set-theory defsort unicode make-event

# Let us wait for everything else before workshops, except we currrently
# (as of v3-6, at least) don't need to wait for coi (that may change).
workshops: $(DIRS1) $(DIRS2_EXCEPT_WK_COI)

$(DIRS1):
	@if [ -f $@/Makefile ]; then cd $@ ; $(MAKE) ; fi

$(DIRS2): top-with-meta-cert
	@if [ -f $@/Makefile ]; then cd $@ ; $(MAKE) ; fi

.PHONY: all-aux
all-aux: $(DIRS1) $(DIRS2_EXCEPT_WK)

# We should really parallelize the compile targets below (fasl, all-fasl,
# all-o, etc.) as with the .cert targets above.  Any volunteers?

# Keep the following pairs in sync with the two targets just above.
# They will create compiled files for books that may have already been
# certified in another lisp (.fasl files for all-fasl, etc.).
# Of course, the underlying lisp of the ACL2 that is run should agree with
# the desired compiled file extension.

# IMPORTANT: In order to use the targets below, you will first need to
# have certified saving expansion files, e.g. with the following 'make'
# argument.
#   ACL2_SAVE_EXPANSION=t

.PHONY: fasl
fasl:
	@date ; $(TIME) $(MAKE) fasl-aux ; date

.PHONY: fasl-aux
fasl-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) fasl ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-fasl
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) fasl ; \
	cd ..) ; \
	fi \
	done

.PHONY: fas
fas:
	@date ; $(TIME) $(MAKE) fas-aux ; date

.PHONY: fas-aux
fas-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) fas ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-fas
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) fas ; \
	cd ..) ; \
	fi \
	done

.PHONY: sparcf
sparcf:
	@date ; $(TIME) $(MAKE) sparcf-aux ; date

.PHONY: sparcf-aux
sparcf-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) sparcf ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-sparcf
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) sparcf ; \
	cd ..) ; \
	fi \
	done

.PHONY: ufsl
ufsl:
	@date ; $(TIME) $(MAKE) ufsl-aux ; date

.PHONY: ufsl-aux
ufsl-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) ufsl ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-ufsl
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) ufsl ; \
	cd ..) ; \
	fi \
	done

.PHONY: 64ufasl
64ufasl:
	@date ; $(TIME) $(MAKE) 64ufasl-aux ; date

.PHONY: 64ufasl-aux
64ufasl-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) 64ufasl ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-64ufasl
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) 64ufasl ; \
	cd ..) ; \
	fi \
	done

.PHONY: x86f
x86f:
	@date ; $(TIME) $(MAKE) x86f-aux ; date

.PHONY: x86f-aux
x86f-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) x86f ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-x86f
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) x86f ; \
	cd ..) ; \
	fi \
	done

.PHONY: o
o:
	@date ; $(TIME) $(MAKE) o-aux ; date

.PHONY: o-aux
o-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) o ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-o
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) o ; \
	cd ..) ; \
	fi \
	done

.PHONY: dfsl
dfsl:
	@date ; $(TIME) $(MAKE) dfsl-aux ; date

.PHONY: dfsl-aux
dfsl-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) dfsl ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-dfsl
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) dfsl ; \
	cd ..) ; \
	fi \
	done

.PHONY: d64fsl
d64fsl:
	@date ; $(TIME) $(MAKE) d64fsl-aux ; date

.PHONY: d64fsl-aux
d64fsl-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) d64fsl ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-d64fsl
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) d64fsl ; \
	cd ..) ; \
	fi \
	done

.PHONY: dx64fsl
dx64fsl:
	@date ; $(TIME) $(MAKE) dx64fsl-aux ; date

.PHONY: dx64fsl-aux
dx64fsl-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) dx64fsl ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-dx64fsl
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) dx64fsl ; \
	cd ..) ; \
	fi \
	done

.PHONY: lx64fsl
lx64fsl:
	@date ; $(TIME) $(MAKE) lx64fsl-aux ; date

.PHONY: lx64fsl-aux
lx64fsl-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) lx64fsl ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-lx64fsl
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) lx64fsl ; \
	cd ..) ; \
	fi \
	done

.PHONY: lx32fsl
lx32fsl:
	@date ; $(TIME) $(MAKE) lx32fsl-aux ; date

.PHONY: lx32fsl-aux
lx32fsl-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) lx32fsl ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-lx32fsl
	@for dir in $(DIRS2_EXCEPT_WK) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) lx32fsl ; \
	cd ..) ; \
	fi \
	done

# Certify all books that need certification.  If you want to get a total time
# for certifying all books, then first do "make clean".
.PHONY: all-plus
all-plus: $(DIRS1) $(ACL2_BOOK_DIRS)

.PHONY: hons clean-hons
# For a parallel "make hons", use e.g.:
#   make hons ACL2_HONS_OPT="-j4"
# In general, ACL2_HONS_OPT is passed to the cert.pl command in centaur/.
hons:
	./cert.pl centaur/doc.lisp \
	  $(ACL2_HONS_OPT) \
	  --acl2-books "`pwd`" \
	  --acl2 $(ACL2_FOR_HONS)

=== books/parallel/Makefile ===
include ../Makefile-generic
-include Makefile-deps

# This is really gross and taken from the xdoc directory for lack of knowing of
# something better.
COMPILE_FLG := t :ttags :all

# Additional dependencies to force serialization when set-compile-fns is set
# (causes a problem for GCL 2.6.*).

matrix-multiplication-parallel.cert: matrix-multiplication-serial.cert
fibonacci.cert: matrix-multiplication-parallel.cert
futures-st.cert: futures-st-raw.lsp

=== books/str/Makefile ===
include ../Makefile-generic

.PHONY: doc

-include Makefile-deps

doc: top.cert
	rm -rf doc
	mkdir doc
	echo '(ld "../doc/write-acl2-html.lisp" :dir :system)' > doc/workxxx
	echo '(ld "../package.lsp")' >> doc/workxxx
	echo '(include-book "../top")' >> doc/workxxx
	echo '(write-html-file :topics (quote (STR::STR)) :pkg "STR")' >> doc/workxxx
	echo '(quit)' >> doc/workxxx
	cd doc; ACL2_SYSTEM_BOOKS=$(abspath $(ACL2_SYSTEM_BOOKS)) $(abspath $(ACL2)) < workxxx
	ls doc/acl2-doc-index.html

clean: clean-more

clean-more:
	rm -rf TAGS

=== books/tools/Makefile ===
include ../Makefile-generic
-include Makefile-deps

# Extra dependencies:

time-dollar-with-gc.cert: time-dollar-with-gc-raw.lsp

=== books/xdoc/Makefile ===
include ../Makefile-generic
-include Makefile-deps

all: $(BOOKS_CERT) bookdoc.dat

.PHONY: moreclean
moreclean:
	rm -rf manual
	rm -rf *.time
	rm -rf bookdoc.dat

clean: moreclean

# Goofy.  We don't want to actually list the dependencies of bookdoc.dat.  In
# principle, we should rebuild it any time any Lisp file in :dir :system is
# changed (and it should be smart enough to figure out which books have
# documentation on its own).  But this is hard.  I don't want to manually
# maintain a giant list of lisp files that bookdoc.dat depends on, and
# automatic dependency scanning is painful in GNU Make, so I don't want to deal
# with it.
#
# (On the above point, added by Matt K.: When we certify with the
# saving of expansion files, as is the case for "make regression" with
# ACL2_SAVE_EXPANSION=t, we create many files *@expansion.lsp.  Since
# there are only three .lsp source files, we enumerate them explicitly
# below in the dependencies for bookdoc.dat.)
#
# Practically speaking, it isn't really crucial that bookdoc.dat be rebuilt all
# the time.  Documentation really isn't updated that frequently, and even if
# the documentation in bookdoc.dat is out of date, the (maybe-import-bookdoc)
# command only adds topics that aren't already loaded, so the user won't see
# outdated documentation at runtime with :xdoc unless they're looking at a
# topic in a book that they haven't loaded.  I think it's reasonable to accept
# this.

bookdoc.dat: acl2-customization.lsp bookdoc.lsp package.lsp $(wildcard *.lisp)
	@$(ACL2) < bookdoc.lsp > bookdoc.out
	@ls -l bookdoc.dat

make-manual.cert: bookdoc.dat

=== books/centaur/vl/Makefile ===
# ACL2 ?= ../../acl2/saved_acl2
# include ../../acl2/books/Makefile-generic
#
# # Dependencies:
#
# BOOKS := $(filter-out acl2-customization,$(BOOKS))
# COMPILE_FLG := t :ttags :all :skip-proofs-okp t
#
# LISPFILES = $(wildcard *.lisp)
# LSPFILES = $(wildcard *.lsp)
# ACL2FILES = $(wildcard *.acl2)
#
# TAGS: $(LISPFILES)
# 	etags *.lisp
#
# -include Makefile-deps


.PHONY: all regression full clean TAGS

all:
	@echo "Use cert.pl to build"
	@echo "Or use 'make full', which runs 'cert.pl -j 8' to build VL,"
	@echo "the VL Server, and VL-Prove and runs some regressions."
	@echo ""

allbooks:
	cert.pl -j 8 top.cert \
                     server/top.cert \
                     ../vl-prove/vl-prove.cert \
                     ../vl-equiv/vl-equiv.cert \
                     lint/lint.cert

full: allbooks
	cd regression; $(MAKE) clean
	cd regression; $(MAKE) all

TAGS:
	@echo "Building TAGS"
	etags `find . -name "*.lisp"` `find . -name "*.lsp"` `find . -name "*.acl2"`

regression:
	@echo "Running regression tests."
	cd regression; $(MAKE) clean
	cd regression; $(MAKE) all

CLEANFILES := *.cert *.lx64fsl *.out *.time *~

clean:
	rm -f $(CLEANFILES) TAGS 
	cd loader; rm -f $(CLEANFILES)
	cd util; rm -f $(CLEANFILES)
	cd transforms; rm -f $(CLEANFILES)
	cd transforms/occform; rm -f $(CLEANFILES)
	cd checkers; rm -f $(CLEANFILES)
	cd mlib; rm -f $(CLEANFILES)
	cd server; rm -f $(CLEANFILES)
	cd lint -f $(CLEANFILES)

=== books/coi/bags/Makefile ===
include ../../Makefile-generic
BOOKS = basic pick-a-point bind-free-rules cons eric-meta \
        meta neq top two-level two-level-meta extras
-include Makefile-deps

clean: clean-coi-extras

clean-coi-extras:
	rm -f Makefile.*

=== books/coi/nary/Makefile ===
include ../../Makefile-generic
BOOKS = nth-rules nary example ordinal-order rewrite-equal-hint
-include Makefile-deps

clean: clean-coi-extras

clean-coi-extras:
	rm -f Makefile.*

=== books/coi/osets/Makefile ===
include ../../Makefile-generic
BOOKS = primitives computed-hints instance membership fast outer sort \
	sets set-order quantify map multicons multiappend listsets set-processor conversions extras
-include Makefile-deps

clean: clean-coi-extras

clean-coi-extras:
	rm -f Makefile.*

=== books/coi/symbol-fns/Makefile ===
include ../../Makefile-generic
BOOKS = symbol-fns symbol-fns-exports
-include Makefile-deps

clean: clean-coi-extras

clean-coi-extras:
	rm -f Makefile.*

=== books/coi/util/Makefile ===
include ../../Makefile-generic
BOOKS = mv-nth iff syntaxp ith fixequiv ifixequiv nfixequiv table \
        good-rewrite-order rewrite-equiv clause-processor defsubtype deffix \
        defdoc defbinding ordinal-order \
        rule-sets-documentation rule-sets  rule-sets-support \
        defun-support defun debug skip-rewrite pseudo-translate \
	in-conclusion implies extra-info extra-info-test ifdef \
        recursion-support
-include Makefile-deps

clean: clean-coi-extras

clean-coi-extras:
	rm -f Makefile.*

=== debian/changelog ===
acl2 (4.3-3) unstable; urgency=low

  * Bug fix: "unowned file /usr/local/share/texmf/ls-R after purge (policy
    6.8, 9.1.2)", thanks to Andreas Beckmann (Closes: #669380).
  * Bug fix: "FTBFS: | /«PKGBUILDDIR»/books/tools/defsum.c:7456:5: error:
    expected expression before &#39;)&#39; token", thanks to Lucas
    Nussbaum (Closes: #669442).  Build-dep on latest gcl

 -- Camm Maguire <camm@debian.org>  Fri, 20 Apr 2012 12:59:26 +0000

acl2 (4.3-2) unstable; urgency=low

  * remove special NO_STRIP for ppc
  * multiply-stacks by 4 on #-native-reloc
  * Bug fix: "Please add support for build-arch and build-indep targets",
    thanks to Niels Thykier (Closes: #647919).

 -- Camm Maguire <camm@debian.org>  Fri, 20 Jan 2012 14:18:55 +0000

acl2 (4.3-1) unstable; urgency=low

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Mon, 09 Jan 2012 21:41:00 +0000

=== debian/control ===
Source: acl2
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: gcl ( >= 2.6.7-100 ), libgmp3-dev, libreadline-dev, emacs23 | emacsen, debhelper ( >= 5 ), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common
Standards-Version: 3.9.3

Package: acl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: acl2-source, acl2-books
Suggests: acl2-emacs
Description: Computational Logic for Applicative Common Lisp: main binary
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the base ACL2 binary. 

Package: acl2-source
Architecture: all
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Depends: ${misc:Depends}	  
Description: Computational Logic for Applicative Common Lisp: source files
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the lisp source files to the main ACL2 binary.

Package: acl2-emacs
Architecture: all
Depends: acl2 (>= ${source:Version}), emacs23 | emacsen, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: emacs interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains an emacs interface to ACL2.

Package: acl2-infix
Architecture: any
Recommends: acl2-infix-source (= ${source:Version})
Depends: acl2 (= ${binary:Version}), texlive-latex-recommended, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains utilities and libraries to access ACL2 via an
 infix notation similar to that used in many non-lisp programming
 languages.

Package: acl2-infix-source
Architecture: all
Depends: ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix source
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the source files to the infix interface to
 ACL2.

Package: acl2-books
Architecture: any
Depends: acl2 (= ${binary:Version}), acl2-books-certs (= ${source:Version}), acl2-books-source (= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: compiled libraries
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains numerous precompiled and precertified libraries
 for use in proving theorems with ACL2.  Serious users will no doubt
 want to install this package.

Package: acl2-books-source
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library sources
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains source lisp files to the compiled libraries
 supplied in the ACL2-books package.

Package: acl2-books-certs
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library certificates
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This file contains certification records for the various precompiled
 libraries supplied in the ACL2-books package.  ACL2 essentially
 requires that all included books be certified before use.

Package: acl2-doc
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Architecture: all
Section: doc
Description: Computational Logic for Applicative Common Lisp: documentation
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the documentation for ACL2.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=4

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=acl2
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)


NO_STRIP:=
# ifeq ($(DEB_BUILD_ARCH),powerpc)
# NO_STRIP:=--exclude=saved_acl2
# endif

books/workshops:
	mkdir $@

#init.lsp.ori: 
#	[ -e $@ ] || mv init.lsp $@

DLOPEN_T:=debian/dlopen.lisp #init.lsp.ori 

#ifeq ($(DEB_BUILD_ARCH),ia64)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),alpha)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mips)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mipsel)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),hppa)
#DLOPEN?=$(DLOPEN_T)
#endif

debian/dlopen.lisp: debian/dlopen.lisp.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

debian/acl2-emacs.emacsen-startup: debian/acl2-emacs.emacsen-startup.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

saved_acl2: debian/patches_applied $(DLOPEN_T)
	echo '(progn (load "debian/sublis_patch.lsp")(si::save-system "pgcl"))' | gcl
	./pgcl -batch -eval "(bye #-native-reloc 1)" || \
		(./pgcl -batch -eval '(load "debian/dlopen.lisp")' && $(MAKE) do_saved)
	./pgcl -batch -eval "(bye #+native-reloc 1)" || $(MAKE) LISP=./pgcl
	mv *$@.gcl $@

saved_acl2.c: saved_acl2
	echo "(f-put-global 'old-certification-dir \"$$(pwd)/books\" state)" \
              "(f-put-global 'new-certification-dir \"/usr/share/$(PD)/books\" state)" \
	      ":q #-native-reloc (setq si::*multiply-stacks* 4) :q #+(or sparc sparc64)(progn (si::sgc-on nil) (fmakunbound 'si::sgc-on))" \
              "(save-exec \"$@\" \"Modified to produce final certification files\")" | ./$<
	mv $@.gcl $@

debian/mini-proveall.out: saved_acl2
	$(MAKE) mini-proveall
	mv $(@F) $@

books/short-test.log: saved_acl2.c
	cp saved_acl2 saved_acl2.ori
	$(MAKE) certify-books-short
	cp saved_acl2.ori saved_acl2

debian/test.log: saved_acl2.c
	mv saved_acl2 saved_acl2.ori
	cp $< saved_acl2
	cd books && \
		BUILDDIR="$$(dirname $$(pwd))" \
		FINALDIR="/usr/share/$(PD)" \
		HOME="/tmp/" \
		$(MAKE) >../$@ 2>&1 & j=$$! ; \
		tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \
		wait $$j
	[ -f $@ ] && ! fgrep '**' $@ || echo FULL TEST FAILS
	for i in $$(find books -name "*.out"); do \
		if ! [ -e $${i%out}cert ] ; then \
			echo $$i ; \
			cat $$i ; \
		fi ; \
	done
	mv saved_acl2.ori saved_acl2
	[ -f $@ ] && ! fgrep '**' $@

interface/infix/Makefile: interface/infix/makefile
	sed -e "s,^DIR = .*,DIR = $$(pwd)/interface/infix,1" \
	    -e "s,^LISP = .*,LISP = $$(pwd)/saved_acl2,1" $< > $@

infix-stamp: interface/infix/Makefile saved_acl2
	cd interface/infix && make -f Makefile compile 
	cd interface/infix && make -f Makefile example 
#	cd interface/infix && make -f Makefile events 
	touch $@

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: debian/mini-proveall.out debian/test.log infix-stamp
	dh_testdir

#	$(MAKE)

	touch build-stamp

infix_clean: interface/infix/Makefile
	rm -f infix-stamp 
	cd interface/infix && make -f Makefile clean
	rm -f interface/infix/Makefile


debian/dpatches: debian/patches.in
	debian/rules debian/patches_unapplied
	cat $< | sed -e "s,@BDIR@,$$(pwd),1" -e "s,@DDIR@,/usr/share/$(PD),1" >$@

debian/patches_applied: debian/dpatches
	! [ -e debian/patches_unapplied ] || \
		(patch -p1 < $< && rm -f debian/patches_unapplied)
	touch $@

debian/patches_unapplied: 
	! [ -e debian/patches_applied ] || ! [ -e debian/dpatches ] ||  \
		(patch -p1 -R < debian/dpatches && rm -f debian/patches_applied)
	touch $@


INSTALLS:=$(addprefix debian/,$(addsuffix .install,acl2 acl2-source acl2-emacs acl2-doc acl2-books acl2-books-source acl2-books-certs acl2-infix acl2-infix-source))
LINKS:=$(addprefix debian/,$(addsuffix .links,acl2 acl2-books acl2-infix))
IFILES:=$(INSTALLS) $(shell ls -1 debian/*.examples debian/*.docs)
debian/README.Debian: debian/README.Debian.in $(IFILES)
	awk '/@PLIST@/ {exit 0} {print}' $< >$@
	for i in $(filter %.install,$^); do\
	 awk '/^debian\// {next} {sub(".final$$","",$$1);$$2="/" $$2;print $$0 " " p}' \
		p=$$(basename $${i%.install}) $$i >>$@ ; done
	for i in $(filter %.info,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/info " p}' p=$$(basename $${i%.info}) $$i >>$@ ; done
	for i in $(filter %.examples,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p "/examples " p}' \
		p=$$(basename $${i%.examples}) $$i >>$@ ; done
	for i in $(filter %.docs,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p " " p}' p=$$(basename $${i%.docs}) $$i >>$@ ; done
	awk '/@PLIST@/ {i=1;next} {if (i) print}' $< >>$@

clean: books/workshops infix_clean debian/patches_unapplied
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	$(MAKE) clean
	$(MAKE) clean-books
	find books -name "*.final" -exec rm {} \;
	rm -f saved_acl2 init_nsaved1_acl2.lsp worklispext
	rm -f debian/mini-proveall.out books/short-test.log debian/test.log
#	! [ -e init.lsp.ori ] || mv init.lsp.ori init.lsp
	rm -f foo.lsp nsaved_acl2
	for i in data c h ; do \
		for j in $$(find -name "*.$$i") ; do\
			k=$$(echo $$j | sed "s,\.$$i$$,,1") ;\
			! [ -e $$k.lisp ] || rm $$j ; \
		done ; \
	done
	rm -f books/bdd/benchmarks.data acl2r.lisp tmp
	rmdir $<
	rm -f debian/dpatches $(INSTALLS) $(LINKS) debian/README.Debian saved_acl2*
	rm -f debian/dlopen.lisp debian/acl2-emacs.emacsen-startup
	rm -f debian/acl2.sh pgcl
	dh_clean -XTAGS

debian/acl2-infix.install:: 
	find interface/infix -name "*.o" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@
	find interface/infix -name "*.sty" | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/texmf/tex/latex\n",$$1);}' >>$@

debian/acl2-infix-source.install:: 
	find interface/infix -name "*.lisp" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-emacs.install:: 
	find interface/emacs -name "*.el" | awk '{printf("%s usr/share/emacs/site-lisp/$(PN)\n",$$1);}' >>$@
	find emacs -name "*.el" | awk '{printf("%s usr/share/emacs/site-lisp/$(PN)\n",$$1);}' >>$@

debian/acl2.install:: 
	echo debian/acl2.sh usr/bin >>$@
	echo saved_acl2 usr/lib/$(PD) >>$@

debian/acl2-books.install:: 
	find books -name "*.o" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-source.install:: 
	find * -name "*.lisp" -maxdepth 0 | grep -v TMP1.lisp | awk '{printf("%s usr/share/$(PD)\n",$$1);}' >$@
	find * -name "TAGS" -maxdepth 0 | awk '{printf("%s usr/share/$(PD)\n",$$1);}' >>$@

debian/acl2-books-certs.install:: 
	find books -name "*.cert" | grep -v fix-cert/moved | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s.final usr/share/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-books-source.install:: 
	find books -name "*.lisp" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find books -name "*.acl2" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find books/bdd -name "bit-vector-reader.lsp" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-doc.install::
	echo doc usr/share/doc/acl2-doc >$@
	find books -name "README*" | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/doc/$(PN)-doc/%s\n",$$1,a);}' >>$@
	find books/textbook -name "*.txt" | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/doc/$(PN)-doc/%s\n",$$1,a);}' >>$@
	find books/textbook -name "*.html" | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/doc/$(PN)-doc/%s\n",$$1,a);}' >>$@
